##LibName#danalyse.r
##LibDescription#Eine Sammlung von Funktionen zur Datenanalyse
##LibDescription#Zur Zeit noch Teststadium
##LibDescription#Version vom 04.02.03
##LibCopyright#Peter Naeve
five.values <- function(x,tukey=F,SIL=T) {
##FunctionName#five.values
##FunctionDescription#Fuenf-Zahlen-Zusammenfassung
##FunctionDescription#Parameter:~
##FunctionDescription#x: Daten als Vektor, Urliste oder Rangwertreihe
##FunctionDescription#   NA`s zugelassen, werden vor Berechnung entfernt
##FunctionDescription#tukey: ==F einfache Version  (Default)
##FunctionDescription#       ==T Tukey-Stil
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription#Value:~
##FunctionDescription#Fuenf-Zahlen-Darstellung als string
##FunctionDescription# last change 27.01.03
##FunctionSyntax#five.values(x), five.value(x,,F), five,values(x,T), ...
erg <- NA
if (is.vector(x) && is.numeric(x)) {
xh  <- x[!is.na(x)]
xh  <- sort(xh)
n   <- length(xh)
h   <- c(" ", " ", " ", " ")
i   <- ceiling(n/2)
d   <- c(n, i)
j   <- ceiling((1 + n)/2)
w   <- (xh[i] + xh[j])/2
if(!(i == j)) h[2] <- "h"
k   <- i
i   <- ceiling(k/2)
j   <- ceiling((1 + k)/2)
d   <- c(d, i, 1)
if(!(i == j)) h[3] <- "h"
w   <- c(w,((xh[i] + xh[j])/2),((xh[n-i+1] + xh[n-j+1])/2),xh[1],xh[n])
d   <- format(d)
w   <- format(w)
k   <- nformat(w[1])
uk  <- rep("_", k)
bk  <- rep(" ", k)
nl  <- "\n"
if (tukey==T) {
mw0 <- c(" # ", d[1], h[1], "   ", uk, uk, uk, nl)
mw1 <- c(" M ", d[2], h[2], " | ", bk, w[1], bk, " | ", nl)
mw2 <- c(" H ", d[3], h[3], " | ", w[2], bk, w[3], " | ", nl)
mw3 <- c("   ", d[4], h[4], " | ", w[4], bk, w[5], " | ", nl)
erg <- cat(mw0, mw1, mw2, mw3, sep = "") }
if (tukey==F) {
mw0 <- c("   ", uk, uk, uk, nl)
mw1 <- c(" | ", bk, w[1], bk, " | ", nl)
mw2 <- c(" | ", w[2], bk, w[3], " | ", nl)
mw3 <- c(" | ", w[4], bk, w[5], " | ", nl)
erg <- cat(mw0, mw1, mw2, mw3, sep = "") }
}else{
if(SIL == F) cat("\nfive.values: Keine zulaessige Eingabe!\n") }
 return(erg)
 invisible()
 }
 nformat <- function(string) {
 ##FunctionName#nformat
 ##FunctionDescription#wird in five.values benoetigt
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#string: ein String
 ##FunctionDescription#Value:~
 ##FunctionDescription#Formatlaenge
 ##FunctionDescription# last change 14.09.02
 ##FunctionSyntax#nformat(string)
 st <- (format(c("", string)))[1]
 z  <- list(" ","  ","   ","    ","     ","      ","       ",
           "        ","         ","          ","           ")
k  <- 0
j  <- 1
for(i in z) { if(i == st) k <- j
              j <- j + 1 }
return(k)
invisible()
}
box.and.whisker <- function(..., kenn=""){
##FunctionName#box.and.whisker
##FunctionDescription#Ein oder mehrere Box-and-Whisker-Plot in einer Graphik
##FunctionDescription#Parameter:~
##FunctionDescription#... liste der Datensaetze
##FunctionDescription#kenn: Vektor der Kennungen der Datensaetze, (optional)
##FunctionDescription# last change 27.01.03
##FunctionSyntax#box.and.whisker(...,kenn)
n <- nargs()
if(kenn[1] != "") n <- n-1
all.x <- list(...)
xmin  <- numeric(n)
xmax  <- numeric(n)
for (i in 1:n){
  x       <- all.x[[i]]
  xmin[i] <- min(x)
  xmax[i] <- max(x) }
xmin  <- min(xmin)
xmax  <- max(xmax)
#setze Benutzer-Koordinatenbereich
y  <- 1.0
dy <- 0.5
xp <- c(xmin,xmax)
yp <- c(0,(2*y*n))
plot(xp,yp,type="n",axes=F,xlab="",ylab="")
title("Box and Whisker Plot")
par(xaxp=c(xmin,xmax,5))
axis(1,ticks=T,pos=0.2)
for (i in 1:n){
x <- all.x[[i]]
x <- quantile(x)
baw(x,y,dy)
if(kenn[1] == "")
tt <- paste("Box.and.Whisker ",format(i),sep="")
 else
tt <- paste("Box.and.Whisker ",kenn[i],sep="")
 text(xmin,y+1,label=tt)
 # next baw
 y <- y+2 }
 invisible() }
 baw<-function(x,y,dy){
 ##FunctionName#baw
 ##FunctionDescription#wird in box.and.whisker benoetigt
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#x: x-Koordinaten box and whisker
 ##FunctionDescription#y: y-Koordinaten box and whisker
 ##FunctionDescription#dy: Boxbreite
 ##FunctionDescription# last change 15.09.02
 ##FunctionSyntax#baw(x,y,dy)
 yu<-y-dy
 yo<-y+dy
 lines(c(x[1],x[2]),c(y,y),type="l")
 lines(c(x[2],x[2]),c(yu,yo),type="l")
 lines(c(x[3],x[3]),c(yu,yo),type="l")
 lines(c(x[4],x[4]),c(yu,yo),type="l")
 lines(c(x[2],x[4]),c(yu,yu),type="l")
 lines(c(x[2],x[4]),c(yo,yo),type="l")
 lines(c(x[4],x[5]),c(y,y),type="l") }
 upper.versus.lower <- function(x,SIL=T){
 ##FunctionName#upper.versus.lower
 ##FunctionDescription#Graph "Obere gegen Untere Datenhaelfte"
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#x: Daten als Vektor, Urliste oder Rangwertreihe
 ##FunctionDescription#   NA`s zugelassen, werden vor Zeichnung entfernt
 ##FunctionDescription#SIL - == F arbeitet mit Ansage
 ##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
 ##FunctionDescription# last change 27.01.03
 ##FunctionSyntax#upper.versus.lower(x), upper.versus.lower(x,F)
 if (is.numeric(x) && is.vector(x)) {
  xh <- x[!is.na(x)]
  h  <- length(x)-length(xh)
  if(SIL == F && h > 0) {
  cat(paste("\nupper.versus.lower: Es wurden", h, "NAs entfernt\n"))}
  n  <- length(xh)
  xs <- sort(xh)
  nh <- floor(n/2)
  plot(xs[1:nh],xs[(n+1)-(1:nh)],xlab="lower",ylab="upper")
  abline(2*median(xh),-1)
  title("Upper versus Lower Plot")
}else{
  if(SIL == F) cat("\nupper.versus.lower: Keine zulaessige Eingabe!\n") }
invisible() }
Spannweite <- function(x,SIL=T) {
##FunctionName#Spannweite
##FunctionDescription#"range" auf deutsch
##FunctionDescription#Parameter:~
##FunctionDescription#x: Daten als Vektor: Urliste oder Rangwertreihe
##FunctionDescription#   NA`s zugelassen, werden vor Berechnung entfernt
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription#Value:~
##FunctionDescription#max(x) - min(x) oder NA
##FunctionDescription# last change 27.01.03
##FunctionSyntax#Spannweite(x), Spannweite(x,F)
erg <- NA
if (is.numeric(x) && is.vector(x)) {
  xh <- x[!is.na(x)]
  h  <- length(x)-length(xh)
  if(SIL == F && h > 0) {
  cat(paste("\nSpannweite: Es wurden", h, "NAs entfernt\n"))}
  xh  <- range(xh)
  erg <- xh[2]-xh[1]
}else{
  if(SIL == F) cat("\nSpannweit: Keine zulaessige Eingabe!\n")}
return(erg)
invisible() }
dHtab <- function(x) {
##FunctionName#dHtab
##FunctionDescription#Erzeugt Klasse "dHtab"
##FunctionDescription#Parameter:~
##FunctionDescription#x: Objekt, das Klasse bekommen soll
##FunctionDescription#Value:~
##FunctionDescription#x: mit Attribut class = "dHtab"
##FunctionDescription# last change 24.09.02
##FunctionSyntax#dHtab(x)
y <- x
class(y) <- c("dHtab", "Htab")
y }
kHtab <- function(x) {
##FunctionName#kHtab
##FunctionDescription#Erzeugt Klasse "kHtab"
##FunctionDescription#Parameter:~
##FunctionDescription#x: Objekt, das Klasse bekommen soll
##FunctionDescription#Value:~
##FunctionDescription#x: mit Attribut class = "kHtab"
##FunctionDescription# last change 24.09.02
##FunctionSyntax#kHtab(x)
y <- x
class(y) <- c("kHtab", "Htab")
y }
print.Htab <- function(x) {
##FunctionName#print.Htab
##FunctionDescription#Methode fuer Klasse "Htab"
##FunctionDescription#Parameter:~
##FunctionDescription#x: Objekt, das geprintet werden soll
##FunctionDescription# last change 24.09.02
##FunctionSyntax#print.Htab(x)
class(x) <- NULL
NextMethod("print")
invisible() }
print.dHtab <- function(x) {
##FunctionName#print.dHtab
##FunctionDescription#Methode fuer Klasse "dHtab"
##FunctionDescription#Parameter:~
##FunctionDescription#x: Objekt, das geprintet werden soll
##FunctionDescription# last change 24.09.02
##FunctionSyntax#print.dHtab(x)
class(x) <- "Htab"
NextMethod("print.Htab")
invisible() }
print.kHtab <- function(x) {
##FunctionName#print.kHtab
##FunctionDescription#Methode fuer Klasse "kHtab"
##FunctionDescription#Parameter:~
##FunctionDescription#x: Objekt, das geprintet werden soll
##FunctionDescription# last change 24.09.02
##FunctionSyntax#print.kHtab(x)
class(x) <- "Htab"
NextMethod("print.Htab")
invisible() }
DiskHaeuf <- function(x,SIL=T) {
##FunctionName#DiskHaeuf
##FunctionDescription#Berechnet diskrete Haeufigkeitstabelle
##FunctionDescription#Parameter:~
##FunctionDescription#x: Daten als Vektor, Urliste oder Rangwertreihe
##FunctionDescription#   NA`s zugelassen, werden vor Berechnung entfernt
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription# last change 27.01.03
##FunctionSyntax#DiskHaeuf(x), DiskHaeuf(x,F)
  erg <- NA
  GO <- F
  if (is.vector(x) && is.numeric(x)) GO <- T
if (GO) {
# drop NAs
    xh    <- x[!is.na(x)]
    h     <- length(x) -length(xh)
    if (SIL == F && h > 0) {
    cat(paste("\nDiskHaeuf: Es wurden",h,"NAs entfernt\n"))}
    n     <- length(xh)
    abs.h <- table(xh)
    xh    <- as.numeric(dimnames(abs.h)[[1]])
    rel.h <- abs.h/n
    rel.h <- zapsmall(rel.h)
    erg   <- cbind(xh, abs.h, rel.h)
# falls man etwas anderes will
    null  <- NULL
    dimnames(erg) <- list(null, c("xi", "ni", "ni/n"))
    erg   <- dHtab(erg)
}else{
    if(SIL == F) cat("\nDiskHaeuf: Kein zulaessiger Datensatz!\n")
     }
return(erg)
invisible() }
Stabdiagramm <- function(x,MNY=T,SIL=T){
##FunctionName#Stabdiagramm
##FunctionDescription#Stabdiagramm einer diskreten Haeufigkeitstabelle
##FunctionDescription#Parameter:~
##FunctionDescription#x: Daten als diskrete Haeufigkeitstabelle
##FunctionDescription#MYN - == F y-Intervall [0 , max(y)]
##FunctionDescription#      == T y-Intervall [0 , 1]    (Default)
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription# last change 27.01.03
##FunctionSyntax#Stabdiagramm(x), Stabdiagramm{x,T}, Stabdiagramm(x,,F),...
  GO     <- F
  xclass <- class(x)
  if ( length(xclass) > 1 && xclass[1] == "dHtab")   GO <- T
if (GO) {
    xx    <- x[,1]
    yy    <- x[,3]
    xmima <- c(xx[1],xx[length(xx)])
    if (MNY == F)  ymima <- c(0,max(yy))
    if (MNY == T)  ymima <- c(0,1)
    plot(xmima,ymima,type="n",xlab="xi",ylab="ni/n")
    title("Stabdiagramm")
    segments(xx,0,xx,yy)
}else{
    if(SIL == F) cat("\nStabdiagramm: Keine diskrete Haeufigkeitstabelle!\n")
}
 invisible() }
 KontHaeuf <- function(x, N=-1, B=-1, S=-1, SIL=T, sf=2) {
 ##FunctionName#KontHaeuf
 ##FunctionDescription#Berechnet kontinuierliche Haeufigkeitstabelle
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#x: Daten als Vektor, Urliste oder Rangwertreihe
 ##FunctionDescription#   NA`s zugelassen, werden vor Berechnung entfernt
 ##FunctionDescription#N: Anzahl Klassen
 ##FunctionDescription#   Default: provided by hist
 ##FunctionDescription#B: Vektor der Klassengrenzen
 ##FunctionDescription#   Default: provided by hist
 ##FunctionDescription#S: Klassenbreite
 ##FunctionDescription#   Default: provided by hist
 ##FunctionDescription#SIL: - == F arbeitet mit Ansage
 ##FunctionDescription#       == T arbeitet ohne Ansage   (Default)
 ##FunctionDescription#sf:  - == Anzahl signifikanter Stellen (Default 2)
 ##FunctionDescription# last change 28.01.03
 ##FunctionSyntax#KontHaeuf(x), KontHaeuf(x,N), KontHaeuf(x,,B), ...
  erg <- NA
  GO <- F
  if (is.vector(x) && is.numeric(x)) GO <- T
if (GO) {
     xh    <- x[!is.na(x)]
     h     <- length(x) -length(xh)
     if (SIL == F && h > 0){
     cat(paste("\nKontHaeuf: Es wurden",h,"NAs entfernt\n"))}
     sw <- 1
     if(length(B) > 1)                               sw <- 2
     if((N != -1)  && (length(B) == 1))              sw <- 3
     if((N == -1)  && (length(B) == 1) && (S != -1)) sw <- 4
     if(sw == 1){ h <- hist(xh, plot = F) }
     if(sw == 2){ h <- hist(xh, breaks = B, plot = F) }
     if(sw == 3){
                   xh <- sort(xh)
                   xu <- xu.nice(xh[1],sf)
                   xo <- xo.nice(xh[length(xh)],sf)
                   ra <- xo - xu
                   xd <- ra/N
                   xb <- xu + (0:N)*xd
                   h  <- hist(xh,breaks = xb, plot = F)
                }
     if(sw == 4){
                   xh <- sort(xh)
                   xu <- xu.nice(xh[1],sf)
                   xo <- xo.nice(xh[length(xh)],sf)
                   ra <- xo - xu
                   nz <- ceiling(ra/S)
                   dd <- nz*S-ra
                   xu <- xu-dd/2
                   xb <- xu+(0:nz)*S
                   h  <- hist(xh,breaks = xb, plot = F)
                }
     k   <- length(h$breaks)
     n   <- sum(h$counts)
     bsm <- zapsmall(h$breaks)
     hsm <- zapsmall(h$counts/n)
     erg <- cbind(bsm[1:(k - 1)], bsm[2:k], h$counts, hsm)
     null <- NULL
     dimnames(erg) <- list(null, c("xsi-1", "xsi", "ni", "ni/n"))
     erg <- kHtab(erg)
}else{
    if(SIL == F) cat("\nKontHaeuf: Kein zulaessiger Datensatz!\n")
}
 return(erg)
 invisible() }
 xo.nice <- function(xo,sf=2) {
 ##FunctionName#xo.nice
 ##FunctionDescription#wird in KontHaeuf benoetigt
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#xo: Obergrenze
 ##FunctionDescription#sf: signifikante Stellen  (Default 2)
 ##FunctionDescription#Value:~
 ##FunctionDescription#Schoene Form von xo
 ##FunctionDescription# last change 28.01.03
 ##FunctionSyntax#xo.nice(xo), xo.nice(xo,sf=3), ...
 xo.a <- abs(xo)
 xo.s <- sign(xo)
 xo.e <- floor(log10(xo.a))
 xo.z <- xo.a*10^(sf-1-xo.e)
 if(xo.s==1)  xo.z <- ceiling(xo.z)
 if(xo.s==-1) xo.z <- floor(xo.z)
 xo.z <-xo.s*xo.z*10^(xo.e-sf+1)
 return(xo.z) }
 xu.nice <- function(xu,sf=2) {
 ##FunctionName#xu.nice
 ##FunctionDescription#wird in KontHaeuf benoetigt
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#xu: Untergrenze
 ##FunctionDescription#sf: signifikante Stellen  (Default 2)
 ##FunctionDescription#Value:~
 ##FunctionDescription#Schoene form von xu
 ##FunctionDescription# last change 28.01.03
 ##FunctionSyntax#xu.nice(xu), xu.nice(xu,sf=3), ...
 xu.a <- abs(xu)
 xu.s <- sign(xu)
 xu.e <- floor(log10(xu.a))
 xu.z <- xu.a*10^(sf-1-xu.e)
 if(xu.s==1)  xu.z <- floor(xu.z)
 if(xu.s==-1) xu.z <- ceiling(xu.z)
 xu.z <-xu.s*xu.z*10^(xu.e-sf+1)
 return(xu.z) }
 Histogramm <- function(x,SIL=T){
 ##FunctionName#Histogramm
 ##FunctionDescription#Histogramm einer kontinuierlichen  Haeufigkeitstabelle
 ##FunctionDescription#Parameter:~
 ##FunctionDescription#x: Daten als kontinuierliche Haeufigkeitstabelle
 ##FunctionDescription#SIL - == F arbeitet mit Ansage
 ##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
 ##FunctionDescription# last change 27.01.03
 ##FunctionSyntax#Histogramm(x), Histogramm(x,F)
  GO     <- F
  xclass <- class(x)
  if ( length(xclass) > 1 && xclass[1] == "kHtab")   GO <- T
if (GO) {
   x1    <- x[,1]
   x2    <- x[,2]
   xd    <- x2-x1
   nn    <- length(x1)
   xx    <- c(x1,x2[nn])
   yy    <- x[,4]
   yy    <- yy/xd
   xmima <- c(x1[1],x2[nn])
   ymima <- c(0,max(yy))
   plot(xmima,ymima,type="n",xlab="xi",ylab="f-dach")
   title("Histogramm")
   segments(x1,0,x1,yy)
   segments(x2,0,x2,yy)
   segments(x1,yy,x2,yy)
   lines(c(x1[1],x2[nn]),c(0,0))
 }else{
if(SIL==F) cat("\nHistogramm: Keine kontinuierliche Haeufigkeitstabelle!\n")
           }
invisible() }
EmpVert <- function(x,MerkName="x",SIL=T) {
##FunctionName#EmpVert
##FunctionDescription#Graph der empirischen Verteilungsfunktion
##FunctionDescription#Parameter:~
##FunctionDescription#x: Daten als Vektor, Urliste oder Rangwertreihe
##FunctionDescription#   NA`s zugelassen, werden vor Zeichnung entfernt
##FunctionDescription#MerkName: Bezeichnung des Merkmals (string), Default "x"
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription# last change 27.01.03
##FunctionSyntax#EmpVert(x), EmpVert(x,MerkName), EmpVert(x,,F), ...
              GO <- F
xclass <- class(x)
if (is.vector(x)       && is.numeric(x))         GO <- T
if (length(xclass) > 1 && xclass[2] == "Htab")   GO <- T
  if (GO) {
  if (is.vector(x)) {
SPRUNG <- T
  xh    <- x[!is.na(x)]
  n     <- length(xh)
  h     <- length(x)-n
  if(SIL == F && h > 0){
  cat(paste("\nEmpVert: Es wurden", h, "NAs entfernt\n"))}
  xh    <- sort(xh)
    # entferne Duplikate
    x1    <- c(xh[-1],2*xh[n])
    ll    <- xh!=x1
    xp    <- xh[ll]
    # ermittle Sprunghoehe
    yp    <- (1:n)[ll]
    yp    <- yp/n
    # Vorbereitung plot
    nn    <- length(xp)
    spann <- (xp[nn]-xp[1])*0.1
    xmima <- c(xp[1]-spann,xp[nn]+spann)
    ymima <- c(0,1)
}else{
    if (xclass[1] == "dHtab") {
     SPRUNG <- T
yp     <- cumsum(x[,3])
xp     <- x[,1]
nn     <- length(xp)
spann  <- (xp[nn]-xp[1])*0.1
xmima  <- c(xp[1]-spann,xp[nn]+spann)
ymima  <- c(0,1)
}
     if (xclass[1] == "kHtab") {
     SPRUNG <- F
yp     <- cumsum(x[,4])
x1     <- x[,1]
x2     <- x[,2]
nn     <- length(x1)
spann  <- (x2[nn]-x1[1])*0.1
xmima  <- c(x1[1]-spann,x2[nn]+spann)
ymima  <- c(0,1)
                   }  }
                   # eigentlicher plot
plot(xmima,ymima,type="n",xlab=MerkName,ylab="F-dach")
 title("Empirische Verteilungsfunktion")
 if (SPRUNG)  segments(xp,yp,c(xp[-1],xp[nn]+spann),yp)
 if (!SPRUNG) lines(c(x1,x2[nn],x2[nn]+spann),c(0,yp,yp[nn]))
                }else{
     if(SIL == F) cat("\nEmpVert: Keine zulaessige Eingabe!\n")
           }
invisible() }
pemp <- function(xq,x,SIL=T) {
##FunctionName#pemp
##FunctionDescription#Parameter:~
##FunctionDescription#xq: Stelle
##FunctionDescription#x:  - Daten als Urliste,
##FunctionDescription#       NAs werden vor Berechnung entfernt
##FunctionDescription#      Daten alsdHtab, kHtab
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription#Value:~
##FunctionDescription#empirische Verteilungsfunktion  an der Stelle xq
##FunctionDescription# last change 27.01.03
##FunctionSyntax#pemp(xq,x), pemp(xq,x,F)
              erg    <- NA
GO     <- F
xclass <- class(x)
if (is.vector(x)        && is.numeric(x))         GO <- T
if ( length(xclass) > 1 && xclass[2] == "Htab")   GO <- T
  if (GO) {
  if (is.vector(x)) {
xh  <- x[!is.na(x)]
  nn  <- length(xh)
  h   <- length(x) - nn
  if(SIL == F && h > 0){
  cat(paste("\npemp: Es wurden", h, "NAs entfernt\n"))}
  erg <- sum(rep(1,nn)[xh <= xq])/nn
}else{
    if (xclass[1] == "dHtab") {
     xx <- x[,1]
nn <- length(xx)
yy <- x[,3]
lo <- T
if(xq<x[1]) { erg <- 0
lo <- F }
   if(xq>x[nn]) { erg <- 1
 lo <- F }
 if(lo) {
          xl  <- xx <= xq
          erg <- sum(yy[xl]) }
}
     if (xclass[1] == "kHtab") {
     di <- x[,2]-x[,1]
hi <- x[,4]
nn <- length(hi)
lo <- T
if(xq<=x[1,1]) { erg <- 0
                          lo <- F }
        if(xq>x[nn,2]) { erg <- 1
                          lo <- F }
        if(lo) {
          h <- 0
          i <- 1
          while ( xq >= x[i,1]) {
            h <- h+ hi[i]
            i <- i+1 }
          erg <- as.vector(h +(xq-x[i,1])*hi[i]/di[i]) }
      } }
                }else{
     if(SIL == F) cat("\npemp: Keine zulaessige Eingabe!\n")
           }
return(erg)
invisible() }
qemp <- function(p,x,MED=F,SIL=T) {
##FunctionName#qemp
##FunctionDescription#Parameter:~
##FunctionDescription#p: Anteil
##FunctionDescription#x: - Daten als Urliste,
##FunctionDescription#      NAs werden vor Berechnung entfernt
##FunctionDescription#     Daten als dHtab oder kHtab
##FunctionDescription#MED - == F arbeitet nach Formel (Default)
##FunctionDescription#      == T arbeitet wie Median bei p=0.5 und Urliste
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription#Value:~
##FunctionDescription#Prozentpunkt f\"ur p
##FunctionDescription# last change 13.02.03
##FunctionSyntax#qemp(p,x), qemp(p,x,F), qemp(0.5,x,T,T)
              erg    <- NA
GO     <- F
xclass <- class(x)
if (is.vector(x)        && is.numeric(x))         GO <- T
if ( length(xclass) > 1 && xclass[2] == "Htab")   GO <- T
if ( p <= 0 || p >= 1)  { GO <- F
                            if(SIL == F) cat("\nqemp: p unzulaessig\n")}
if (GO) {
  if (is.vector(x)) {
      xh  <- x[!is.na(x)]
      nn  <- length(xh)
      h   <- length(x) - nn
      if(SIL == F && h > 0){
        cat(paste("\nqemp: Es wurden", h, "NAs entfernt\n"))}
      xh  <- sort(xh)
      if((zapsmall(p-0.5)== 0) && (MED==T)) {
      if(SIL==F) cat("\nqemp: Median-Modus an\n")
      np  <- nn*p
      n1  <- ceiling(np)
      h   <- 0
      if(nn==(2*n1)) h <- 1
      n2  <- n1+h
      erg <- (xh[n1]+xh[n2])/2

      }else{
       Fi  <- (1:nn)/nn
       i   <- 1
       while (p > Fi[i] ) i <- i+1
       erg <- as.vector(xh[i]) }
}else{
    if (xclass[1] == "dHtab") {
     hi  <- x[,3]
Fi  <- cumsum(hi)
i   <- 1
while (p > Fi[i] ) i <- i+1
erg <- as.vector(x[i,1])
}
     if (xclass[1] == "kHtab") {
     di  <- x[,2]-x[,1]
hi  <- x[,4]
xi  <- x[,1]
Fi  <- c(0,cumsum(hi))

     i   <- 1
while (p > Fi[i+1] ) i <- i+1
erg <- as.vector(xi[i]  + (p - Fi[i])/hi[i]*di[i])

                   } }
                   }else{
    if(SIL == F) cat("\nqemp: Keine zulaessige Eingabe!\n")
  }
return(erg)
invisible() }
Median <- function(x,SIL=T) {
##FunctionName#Median
##FunctionDescription#Parameter:~
##FunctionDescription#x: - Daten als Urliste,
##FunctionDescription#      NAs werden vor Berechnung entfernt
##FunctionDescription#     Daten als dHtab oder kHtab
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription#Value:~
##FunctionDescription#Median
##FunctionDescription# last change 13.02.03
##FunctionSyntax#Median(x), Median(x,F)
              p      <- 0.5
erg    <- NA
GO     <- F
xclass <- class(x)
if (is.vector(x)        && is.numeric(x))         GO <- T
if ( length(xclass) > 1 && xclass[2] == "Htab")   GO <- T
  if (GO) {
  if (is.vector(x)) {
xh  <- x[!is.na(x)]
  nn  <- length(xh)
  h   <- length(x) - nn
  if(SIL == F && h > 0){
        cat(paste("\nMedian: Es wurden", h, "NAs entfernt\n"))}
      xh  <- sort(xh)
      np  <- nn*p
      n1  <- ceiling(np)
      h   <- 0
      if(nn==(2*n1)) h <- 1
      n2  <- n1+h
      erg <- (xh[n1]+xh[n2])/2
}else{
    if (xclass[1] == "dHtab") {
     hi  <- x[,3]
Fi  <- cumsum(hi)
i   <- 1
while (p > Fi[i] ) i <- i+1
erg <- as.vector(x[i,1])
}
     if (xclass[1] == "kHtab") {
     di  <- x[,2]-x[,1]
hi  <- x[,4]
xi  <- x[,1]
Fi  <- c(0,cumsum(hi))

     i   <- 1
while (p > Fi[i+1] ) i <- i+1
erg <- as.vector(xi[i]  + (p - Fi[i])/hi[i]*di[i])

                   } }
                   }else{
    if(SIL == F) cat("\nMedian: Keine zulaessige Eingabe!\n")
  }
return(erg)
invisible() }
Mittelwert <- function(x,SIL=T) {
##FunctionName#Mittelwert
##FunctionDescription#Arithmetisches Mittel
##FunctionDescription#Parameter:~
##FunctionDescription#x:  - Vektor: Urliste oder Rangwertreihe
##FunctionDescription#      NA`s zugelassen, werden vor Berechnung entfernt
##FunctionDescription#    - Daten als diskrete Haeufigkeitstabelle
##FunctionDescription#    - Daten als kontinuierliche Haeufigkeitstabelle
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage   (Default)
##FunctionDescription#Value:~
##FunctionDescription#Mittelwert von x oder NA
##FunctionDescription# last change 26.01.03
##FunctionSyntax#Mittelwert(x), Mittelwert(x,F)
              erg    <- NA
GO     <- F
xclass <- class(x)
if (is.vector(x)       && is.numeric(x))         GO <- T
if ( length(xclass) >1 && xclass[2] == "Htab")   GO <- T
  if (GO) {
  if (is.vector(x)) {
     if(SIL == F) cat("\n Mittelwert aus Urliste\n")
     xh <- x[!is.na(x)]
     h  <- length(x) - length(xh)
     if(SIL == F && h > 0) {
       cat(paste("\nMittelwert: Es wurden", h, "NAs entfernt\n")) }
     erg <- mean(xh)
}else{
    if (xclass[1] == "dHtab") {
     if(SIL==F) cat("\n Mittelwert aus diskreter Haeufigkeitstabelle\n")
erg <- sum(x[, 1] * x[, 3])
}
     if (xclass[1] == "kHtab") {
         if(SIL==F){
           cat("\n Mittelwert aus kontinuierlicher Haeufigkeitstabelle\n")}
         erg <- sum(((x[, 2] + x[, 1]) * 0.5) * x[, 4])
      } }
                }else{
     if(SIL == F) cat("\nMittelwert: Keine zulaessige Eingabe!\n")
           }
return(erg)
invisible() }
Varianz<- function(x,SIL=T) {
##FunctionName#Varianz
##FunctionDescription#Varianz
##FunctionDescription#Parameter:~
##FunctionDescription#x:  - Vektor: Urliste oder Rangwertreihe
##FunctionDescription#      NA`s zugelassen, werden vor Berechnung entfernt
##FunctionDescription#    - Daten als diskrete Haeufigkeitstabelle
##FunctionDescription#    - Daten als kontinuierliche Haeufigkeitstabelle
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage  (Default)
##FunctionDescription#Value:~
##FunctionDescription#Varianz von x oder NA
##FunctionDescription# last change 04.02.03
##FunctionSyntax#Varianz(x), Varianz(x,F)
              erg    <- NA
GO     <- F
xclass <- class(x)
if (is.vector(x)        && is.numeric(x))           GO <- T
if ( length(xclass) > 1 && xclass[[2]] == "Htab")   GO <- T
  if (GO) {
  if (is.vector(x)) {
if(SIL == F) cat("\n Varianz aus Urliste\n")
  xh <- x[!is.na(x)]
  h <- length(x) - length(xh)
  if(SIL == F && h > 0){
        cat(paste("\nVarianz: Es wurden", h, "NAs entfernt\n"))}
      erg <- var(xh)
}else{
    if (xclass[[1]] == "dHtab") {
        if(SIL == F){
          cat("\n Varianz aus diskreter Haeufigkeitstabelle\n")}
     n   <- sum(x[,2])
xq  <- sum(x[, 1] * x[, 2])/n
erg <- (sum( ((x[,1]-xq )^2 ) * x[,2] ))/(n-1)
}
     if (xclass[[1]] == "kHtab") {
        if(SIL == F){
          cat("\n Varianz aus kontinuierlicher Haeufigkeitstabelle\n")}
     n   <- sum(x[,3])
xmi <- (x[, 2] + x[, 1]) * 0.5
xq  <- sum(xmi* x[, 3])/n
erg <- (sum( ((xmi-xq )^2 ) * x[,3] ) )/(n-1)
                   } }
                   }else{
    if(SIL == F) cat("\nVarianz: Keine zulaessige Eingabe!\n")
  }
return(erg)
invisible() }
MQA<- function(x,SIL=T) {
##FunctionName#MQA
##FunctionDescription#MQA
##FunctionDescription#Parameter:~
##FunctionDescription#x:  - Vektor: Urliste oder Rangwertreihe
##FunctionDescription#      NA`s zugelassen, werden vor Berechnung entfernt
##FunctionDescription#    - Daten als diskrete Haeufigkeitstabelle
##FunctionDescription#    - Daten als kontinuierliche Haeufigkeitstabelle
##FunctionDescription#SIL - == F arbeitet mit Ansage
##FunctionDescription#      == T arbeitet ohne Ansage  (Default)
##FunctionDescription#Value:~
##FunctionDescription#MQA von x oder NA
##FunctionDescription# last change 04.02.03
##FunctionSyntax#MQA(x), MQA(x,F)
              erg    <- NA
GO     <- F
xclass <- class(x)
if (is.vector(x)        && is.numeric(x))           GO <- T
if ( length(xclass) > 1 && xclass[[2]] == "Htab")   GO <- T
  if (GO) {
  if (is.vector(x)) {
if(SIL == F) cat("\n MQA aus Urliste\n")
  xh <- x[!is.na(x)]
  h <- length(x) - length(xh)
  if(SIL == F && h > 0){
        cat(paste("\nMQA: Es wurden", h, "NAs entfernt\n"))}
      n   <- length(xh)
      erg <- var(xh)*(n-1)/n
}else{
    if (xclass[[1]] == "dHtab") {
        if(SIL == F){
          cat("\n MQA aus diskreter Haeufigkeitstabelle\n")}
     n   <- sum(x[,2])
xq  <- sum(x[, 1] * x[, 2])/n
erg <- (sum( ((x[,1]-xq )^2 ) * x[,2] ))/n
}
     if (xclass[[1]] == "kHtab") {
        if(SIL == F){
          cat("\n MQA aus kontinuierlicher Haeufigkeitstabelle\n")}
     n   <- sum(x[,3])
xmi <- (x[, 2] + x[, 1]) * 0.5
xq  <- sum(xmi* x[, 3])/n
erg <- (sum( ((xmi-xq )^2 ) * x[,3] ) )/n
                   } }
                   }else{
    if(SIL == F) cat("\nMQA: Keine zulaessige Eingabe!\n")
  }
return(erg)
invisible() }
